function MLE=findMLEHa(J,M)
kk=0;
d0=1;
d=0;
p0=zeros(J,1);r0=zeros(J,1);
 for j=1:J
        m=M(:,2*(j-1)+1:2*j);
        ss=sum(m); m1=ss(1); m2=ss(2);
        m01=m(1,1);m02=m(1,2);m11=m(2,1);m12=m(2,2);m21=m(3,1);m22=m(3,2);
        p0(j)=(m11+m12+2*m21+2*m22)/(2*(m1+m2));
        r0(j)=(4*(m01+m02)*(m21+m22)-(m11+m12)^2)/((m11+m12+2*m01+2*m02)*(m11+m12+2*m21+2*m22));
 end

while (abs(d-d0)>1.e-5 && kk<100)
    kk=kk+1;
    d=d0;
    I11=0;I12=zeros(1,J);I13=zeros(1,J);I22=zeros(J,J);I23=zeros(J,J);I33=zeros(J,J);df=zeros(2*J+1,1);
    sumdfdj=0;
    
    for j=1:J
        m=M(:,2*(j-1)+1:2*j);
        ss=sum(m); m1=ss(1); m2=ss(2);
        m01=m(1,1);m02=m(1,2);m11=m(2,1);m12=m(2,2);m21=m(3,1);m22=m(3,2);
        p=p0(j);
        r=r0(j);
   
        I11=I11+m2*p^2*(((1+2*d^2*p^2)*(1-r)^2-2*d*p*(1-r)*(2-r)+1)/(r*(1-d*p)+(1-r)*(1-d*p)^2)+(2*(1-r)*(2*d^2*p^2-2*d*p+1))/(d*p*(1-d*p))+(2*d^2*p^2*(1-r)^2+2*d*p*r*(1-r)+r^2)/(r*d*p+(1-r)*(d*p)^2));
        sumdfdj=sumdfdj+(-m02*p*(2*(1-r)*(1-d*p)+r))/(r*(1-d*p)+(1-r)*(1-d*p)^2)+(m12*(1-2*d*p))/(d*(1-d*p))+(m22*(2*d*p*(1-r)+r))/(d*r+(1-r)*d^2*p);
        I22(j,j)=(2*m1*(2*p - 1)*(r - 1))/p - 4*d^2*m2*(r - 1) - 4*m1*(r - 1) + (2*m1*(2*p - 1)*(r - 1))/(p - 1) - (m1*(2*r - 2)*((r - 1)*p^2 - r*p))/(p*(p + r - p*r)) + (m1*(2*r - 2)*((p - 1)^2*(r - 1) + r*(p - 1)))/((p - 1)*(p*r - p + 1)) - (m1*((r - 1)*p^2 - r*p)*(2*p + r - 2*p*r)^2)/(p^2*(p + r - p*r)^2) + (2*d*m2*(2*d*p - 1)*(r - 1))/p - (m1*((p - 1)^2*(r - 1) + r*(p - 1))*(2*p + r - 2*p*r - 2)^2)/((p - 1)^2*(p*r - p + 1)^2) + (m2*((1 - r)*d^2*p^2 + r*d*p)*(r + 2*d*p - 2*d*p*r)^2)/(p^2*(r + d*p - d*p*r)^2) + (2*d^2*m2*(2*d*p - 1)*(r - 1))/(d*p - 1) - (d^2*m2*((d*p - 1)^2*(r - 1) + r*(d*p - 1))*(r + 2*d*p - 2*d*p*r - 2)^2)/((d*p - 1)^2*(d*p*r - d*p + 1)^2) + (2*d*m2*((1 - r)*d^2*p^2 + r*d*p)*(r - 1))/(p*(r + d*p - d*p*r)) + (2*d^2*m2*(r - 1)*((d*p - 1)^2*(r - 1) + r*(d*p - 1)))/((d*p - 1)*(d*p*r - d*p + 1));
        I23(j,j)=2*m1*(2*p - 1) - m1*(4*p - 2) + (m2*(2*d*p - 1)*((1 - r)*d^2*p^2 + r*d*p))/(p*(r + d*p - d*p*r)) - (m1*(2*p - 1)*((r - 1)*p^2 - r*p))/(p*(p + r - p*r)) + (m1*(2*p - 1)*((p - 1)^2*(r - 1) + r*(p - 1)))/((p - 1)*(p*r - p + 1)) + (d*m2*(2*d*p - 1)*((d*p - 1)^2*(r - 1) + r*(d*p - 1)))/((d*p - 1)*(d*p*r - d*p + 1)) + (m1*p*((p - 1)^2*(r - 1) + r*(p - 1))*(2*p + r - 2*p*r - 2))/((p - 1)*(p*r - p + 1)^2) - (m2*(d*p - 1)*((1 - r)*d^2*p^2 + r*d*p)*(r + 2*d*p - 2*d*p*r))/(p*(r + d*p - d*p*r)^2) + (m1*((r - 1)*p^2 - r*p)*(p - 1)*(2*p + r - 2*p*r))/(p*(p + r - p*r)^2) + (d^2*m2*p*((d*p - 1)^2*(r - 1) + r*(d*p - 1))*(r + 2*d*p - 2*d*p*r - 2))/((d*p - 1)*(d*p*r - d*p + 1)^2);
        I33(j,j)=(2*m1*p*(p - 1))/(r - 1) - (m1*((r - 1)*p^2 - r*p)*(p - 1)^2)/(p + r - p*r)^2 + (m2*(d*p - 1)^2*((1 - r)*d^2*p^2 + r*d*p))/(r + d*p - d*p*r)^2 - (m1*p^2*((p - 1)^2*(r - 1) + r*(p - 1)))/(p*r - p + 1)^2 + (2*d*m2*p*(d*p - 1))/(r - 1) - (d^2*m2*p^2*((d*p - 1)^2*(r - 1) + r*(d*p - 1)))/(d*p*r - d*p + 1)^2;
        df(1)=sumdfdj;
        df(1+j)=(m01*(r + (2*p - 2)*(r - 1)))/((p - 1)^2*(r - 1) + r*(p - 1)) - (m21*(r - 2*p*(r - 1)))/((r - 1)*p^2 - r*p) + (m02*(d*r + 2*d*(d*p - 1)*(r - 1)))/((d*p - 1)^2*(r - 1) + r*(d*p - 1)) + (m22*(- 2*p*(r - 1)*d^2 + r*d))/((1 - r)*d^2*p^2 + r*d*p) + (m11*(2*(p - 1)*(r - 1) + 2*p*(r - 1)))/(2*p*(p - 1)*(r - 1)) + (m12*(2*d*(d*p - 1)*(r - 1) + 2*d^2*p*(r - 1)))/(2*d*p*(d*p - 1)*(r - 1));
        df(1+J+j)=m11/(r - 1) + m12/(r - 1) + (m01*p)/(p*r - p + 1) - (m22*(d*p - 1))/(r + d*p - d*p*r) - (m21*(p - 1))/(p + r - p*r) + (d*m02*p)/(d*p*r - d*p + 1);
        
    end
    I=[I11,I12,I13;I12',I22,I23;I13',I23,I33];
    d0p0r0=[d;p0;r0]+inv(I)*df;
     d0= d0p0r0(1);
    p0= d0p0r0(2:J+1);
    r0= d0p0r0(J+2:2*J+1);
end 

MLE=[d0,p0',r0'];

end